<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>C# Tribute Page</title>
    <link rel="stylesheet" href="style.css">
</head>
<body>
<header></header>
<main id="main">
    <h1 id="title">C# (programming language)</h1>
    <p id="summary">
        C# (pronounced see sharp, like the musical note C♯, but written with the number sign) is a general-purpose,
        multi-paradigm programming language encompassing static typing, strong typing, lexically scoped, imperative,
        declarative, functional, generic, object-oriented (class-based), and component-oriented programming disciplines.
    </p>

    <figure id="img-div">
        <img id="image"
             src="img/c_sharp-logo.png"
             alt="C# Logo">
        <a id="img-link" href="img/c_sharp-logo.png"> </a>
        <figcaption id="img-caption">C# Logo</figcaption>
    </figure>

    <section id="tribute-info">
        <div class="wrap-container">
            <div class="card">
                <h2>C# 2.0 (2005)</h2>
                <hr>
                <ul>
                    <li>Generics</li>
                    <li>Partial types</li>
                    <li>Anonymous methods</li>
                    <li>Iterators</li>
                    <li>Nullable value types</li>
                    <li>Getter/setter separate accessibility</li>
                    <li>Method group conversions (delegates)</li>
                    <li>Co- and Contra-variance for delegates</li>
                    <li>Static classes</li>
                    <li>Delegate inference</li>
                    <li>Null coalescing operator</li>
                </ul>
            </div>

            <div class="card">
                <h2>C# 3.0 (2007)</h2>
                <hr>
                <ul>
                    <li>Implicitly typed local variables</li>
                    <li>Object and collection initializers</li>
                    <li>Auto-Implemented properties</li>
                    <li>Anonymous types</li>
                    <li>Extension methods</li>
                    <li>Query expressions</li>
                    <li>Lambda expressions</li>
                    <li>Expression trees</li>
                    <li>Partial methods</li>
                </ul>
            </div>

            <div class="card">
                <h2>C# 4.0 (2010)</h2>
                <hr>
                <ul>
                    <li>Dynamic binding</li>
                    <li>Named and optional arguments</li>
                    <li>Generic co- and contravariance</li>
                    <li>Embedded interop types ("NoPIA")</li>
                </ul>
            </div>

            <div class="card">
                <h2>C# 5.0 (2012)</h2>
                <hr>
                <ul>
                    <li>Asynchronous methods</li>
                    <li>Caller info attributes</li>
                </ul>
            </div>

            <div class="card">
                <h2>C# 6.0 (2015)</h2>
                <hr>
                <ul>
                    <li>Compiler-as-a-service (Roslyn)</li>
                    <li>Import of static type members into namespace</li>
                    <li>Exception filters</li>
                    <li>Await in catch/finally blocks</li>
                    <li>Auto property initializers</li>
                    <li>Default values for getter-only properties</li>
                    <li>Expression-bodied members</li>
                    <li>Null propagator (null-conditional operator, succinct null checking)</li>
                    <li>String interpolation</li>
                    <li>nameof operator</li>
                    <li>Dictionary initializer</li>
                </ul>
            </div>
        </div>

        <p>
            And many more at&nbsp;
            <a href="https://en.wikipedia.org/wiki/C_Sharp_(programming_language)#New_features"
               target="_blank">
                Wikipedia
            </a>
        </p>
    </section>
</main>
<footer>
    <strong id="find-out-more">Find out more about&nbsp;
        <a href="https://en.wikipedia.org/wiki/C_Sharp_(programming_language)"
           id="tribute-link"
           target="_blank">
            C#
        </a>.
    </strong>
</footer>

<script src="https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js"></script>
</body>
</html>
